#ifndef __GMESSAGE_H
#define __GMESSAGE_H

typedef struct _GMessage {
  int       *name_len;       /* lengths of names     */
  int       *data_len;       /* lengths of data      */
  char      **name;          /* name array           */
  char      **data;          /* data array           */
  int       cur_len;         /* length of name/data  */
  int       avail;           /* available slots left */
  char      *serial;         /* serialized structure */
  int       serial_len;      /* length of serial str */
  char      *get_tmp;        /* don't ask            */
  int       is_inited;       /* init_gmessage()      */
} GMessage;

GMessage * init_gmessage ();
void deinit_gmessage (GMessage *mesg);

void gmessage_put (GMessage *mesg, char *name, int name_len, char *data, int data_len);
int gmessage_get (GMessage *mesg, char *name, int name_len, char *data[]);
char * gmessage_getx (GMessage *mesg, char *name, int name_len, int *data_len);
void gmessage_remove (GMessage *mesg, char *name, int name_len);
void gmessage_remove_all (GMessage *mesg);

int gmessage_serialize (GMessage *mesg);
GMessage * gmessage_deserialize (GMessage *mesg, char *data, int data_len);

int gmessage_enlarge (GMessage *mesg);

void gmessage_strcpy (char *src_str, int src_len, char *dst_str);
int gmessage_strcmp (char *a_str, int a_len, char *b_str, int b_len);
int gmessage_getpos (GMessage *mesg, char *name, int name_len);
int gmessage_atoi (char *numb, int numb_len);

#endif /* __GMESSAGE_H */

