#ifndef __GRID_H
#define __GRID_H

#include "xgslave.h"

#define GRID_SIZE_ROW 8
#define GRID_SIZE_COL 6
#define GRID_SIZE     GRID_SIZE_ROW * GRID_SIZE_COL

typedef struct _GridLoc {
  unsigned int     serial;
  char             *name;
  int              pos_h;
  int              pos_v;
  GSlave           *gslave;
} GridLoc;

typedef struct _Grid {
  int       count;
  int       width;
  int       height;
  int       **grid;
  char      *name;
} Grid;

int grid_add (Grid *grid, GridLoc *gloc);
void grid_del (Grid *grid, GridLoc *gloc);
void grid_remove (Grid *grid, char *name);
int grid_move (Grid *grid, int from_h, int from_v, int to_h, int t_v);
int grid_switch (Grid *grid, GridLoc *from, GridLoc *to);

GridLoc * grid_get (Grid *grid, GridLoc *gloc, int dir);
GridLoc * grid_getbyname (Grid *grid, char *name);

Grid * init_grid ();
void deinit_grid (Grid *grid);

GridLoc * init_gridloc ();
void deinit_gridloc (GridLoc *gloc);

void gridloc_setname (GridLoc *gloc, char *name);
char * gridloc_getname (GridLoc *gloc);

#endif /* __GRID_H */

